Yate

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
UIWidget Class Reference
Inheritance diagram for UIWidget:

## Public Member Functions
| UIWidget (const char *name=0)
virtual | ~UIWidget ()
const String & | name () const
virtual bool | setParams (const NamedList &params)
virtual bool | getOptions (NamedList &items)
virtual bool | addTableRow (const String &item, const NamedList *data=0, bool atStart=false)
virtual bool | setMultipleRows (const NamedList &data, const String &prefix=String::empty())
virtual bool | updateTableRows (const NamedList *data, bool atStart=false)
virtual bool | insertTableRow (const String &item, const String &before, const NamedList *data=0)
virtual bool | delTableRow (const String &item)
virtual bool | setTableRow (const String &item, const NamedList *data)
virtual bool | getTableRow (const String &item, NamedList *data=0)
virtual bool | clearTable ()
virtual bool | setSelect (const String &item)
virtual bool | getSelect (String &item)
virtual bool | getSelect (NamedList &items)
virtual bool | addLines (const NamedList &lines, unsigned int max, bool atStart=false)
virtual bool | setText (const String &text, bool richText=false)
virtual bool | getText (String &text, bool richText=false)
virtual bool | setBusy (bool on)
Public Member Functions inherited from String
| String ()
| String (const char *value, int len=-1)
| String (char value, unsigned int repeat=1)
| String (int32_t value)
| String (uint32_t value)
| String (int64_t value)
| String (uint64_t value)
| String (bool value)
| String (double value)
| String (const String &value)
| String (const String *value)
virtual | ~String ()
virtual void * | getObject (const String &name) const
const char * | c_str () const
const char * | safe () const
const char * | safe (const char *defStr) const
unsigned int | length () const
bool | null () const
int | lenUtf8 (uint32_t maxChar=0x10ffff, bool overlong=false) const
int | fixUtf8 (const char *replace=0, uint32_t maxChar=0x10ffff, bool overlong=false)
unsigned int | encodeFlags (const TokenDict *tokens) const
uint64_t | encodeFlags (const TokenDict64 *tokens) const
const String & | decodeFlags (unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
const String & | decodeFlags (uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
bool | checkBOM () const
bool | stripBOM ()
unsigned int | hash () const
void | clear ()
char | at (int index) const
String | substr (int offs, int len=-1) const
String & | trimBlanks ()
String & | trimSpaces ()
virtual const String & | toString () const
int | toInteger (int defvalue=0, int base=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | toInteger (const TokenDict *tokens, int defvalue=0, int base=0) const
long int | toLong (long int defvalue=0, int base=0, long int minvalue=LONG_MIN, long int maxvalue=LONG_MAX, bool clamp=true) const
int64_t | toInt64 (int64_t defvalue=0, int base=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
uint64_t | toUInt64 (uint64_t defvalue=0, int base=0, uint64_t minvalue=0, uint64_t maxvalue=ULLONG_MAX, bool clamp=true) const
double | toDouble (double defvalue=0.0) const
bool | toBoolean (bool defvalue=false) const
bool | isBoolean () const
String & | toUpper ()
String & | toLower ()
char | operator[] (signed int index) const
char | operator[] (unsigned int index) const
| operator const char * () const
String & | assign (const char *value, int len=-1)
String & | assign (char value, unsigned int repeat=1)
String & | hexify (void *data, unsigned int len, char sep=0, bool upCase=false)
String & | operator= (const String &value)
String & | operator= (const String *value)
String & | operator= (const char *value)
String & | operator= (char value)
String & | operator= (int32_t value)
String & | operator= (uint32_t value)
String & | operator= (int64_t value)
String & | operator= (uint64_t value)
String & | operator= (bool value)
String & | operator= (double value)
String & | operator+= (const char *value)
String & | operator+= (char value)
String & | operator+= (int32_t value)
String & | operator+= (uint32_t value)
String & | operator+= (int64_t value)
String & | operator+= (uint64_t value)
String & | operator+= (bool value)
String & | operator+= (double value)
bool | operator== (const char *value) const
bool | operator!= (const char *value) const
bool | operator== (const String &value) const
bool | operator!= (const String &value) const
bool | operator&= (const char *value) const
bool | operator|= (const char *value) const
String & | operator<< (const char *value)
String & | operator<< (char value)
String & | operator<< (int32_t value)
String & | operator<< (uint32_t value)
String & | operator<< (int64_t value)
String & | operator<< (uint64_t value)
String & | operator<< (bool value)
String & | operator<< (double value)
String & | operator>> (const char *skip)
String & | operator>> (char &store)
String & | operator>> (UChar &store)
String & | operator>> (int &store)
String & | operator>> (unsigned int &store)
String & | operator>> (bool &store)
String & | append (const char *value, int len)
String & | append (const char *value, const char *separator=0, bool force=false)
String & | append (const ObjList *list, const char *separator=0, bool force=false)
String & | append (const ObjList &list, const char *separator=0, bool force=false)
String & | append (double value, unsigned int decimals=3)
String & | printf (const char *format,...)
String & | printf (unsigned int length, const char *format,...)
String & | appendFixed (unsigned int fixedLength, const char *str, unsigned int len=-1, char fill= ' ', int align=Left)
String & | appendFixed (unsigned int fixedLength, const String &str, char fill= ' ', int align=Left)
int | find (char what, unsigned int offs=0) const
int | find (const char *what, unsigned int offs=0) const
int | rfind (char what) const
int | rfind (const char *what) const
bool | startsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | endsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | startSkip (const char *what, bool wordBreak=true, bool caseInsensitive=false)
String & | extractTo (const char *sep, String &store)
String & | extractTo (const char *sep, bool &store)
String & | extractTo (const char *sep, int &store, int base=0)
String & | extractTo (const char *sep, int &store, const TokenDict *tokens, int base=0)
String & | extractTo (const char *sep, double &store)
virtual bool | matches (const String &value) const
bool | matches (const Regexp &rexp)
int | matchOffset (int index=0) const
int | matchLength (int index=0) const
String | matchString (int index=0) const
String | replaceMatches (const String &templ) const
int | matchCount () const
ObjList * | split (char separator, bool emptyOK=true) const
ObjList * | split (const Regexp &reg, bool emptyOK=true) const
String | msgEscape (char extraEsc=0) const
String | msgUnescape (int *errptr=0, char extraEsc=0) const
String | sqlEscape (char extraEsc=0) const
String | uriEscape (char extraEsc=0, const char *noEsc=0) const
String | uriUnescape (int *errptr=0) const
Public Member Functions inherited from GenObject
| GenObject ()
virtual | ~GenObject ()
virtual bool | alive () const
virtual void | destruct ()
virtual const String & | traceId () const
NamedCounter * | getObjCounter () const
NamedCounter * | setObjCounter (NamedCounter *counter)

## Additional Inherited Members
Public Types inherited from String
enum | Align { Left = 0, Center, Right }
Static Public Member Functions inherited from String
static const String & | empty ()
static const char * | boolText (bool value)
static int | lenUtf8 (const char *value, uint32_t maxChar=0x10ffff, bool overlong=false)
static bool | checkBOM (const char *str)
static bool | stripBOM (const char *&str)
static bool | stripBOM (char *&str)
static unsigned int | hash (const char *value, unsigned int h=0)
static String | msgEscape (const char *str, char extraEsc=0)
static String | msgUnescape (const char *str, int *errptr=0, char extraEsc=0)
static String | sqlEscape (const char *str, char extraEsc=0)
static String | uriEscape (const char *str, char extraEsc=0, const char *noEsc=0)
static String | uriEscape (const char *str, const char *extraEsc, const char *noEsc=0)
static String | uriUnescape (const char *str, int *errptr=0)
static const String * | atom (const String *&str, const char *val)
Static Public Member Functions inherited from GenObject
static void * | getObject (const String &name, const GenObject *obj)
static bool | getObjCounting ()
static void | setObjCounting (bool enable)
static NamedCounter * | getObjCounter (const String &name, bool create=true)
static ObjList & | getObjCounters ()
Protected Member Functions inherited from String
virtual void | changed ()

## Constructor & Destructor Documentation

UIWidget | ( | const char * | name = `0` | ) |
| inline explicit

Constructor, creates a new widget

Parameters

  name | The widget's name

virtual ~UIWidget | ( |  | ) |
| inline virtual

Destructor

## Member Function Documentation

virtual bool addLines | ( | const NamedList & | lines,
|  | unsigned int | max,
|  | bool | atStart = `false`
| ) |  |
| inline virtual

Append or insert text lines to this widget

Parameters

  lines | List containing the lines
  max | The maximum number of lines allowed to be displayed. Set to 0 to ignore
  atStart | True to insert, false to append

Returns
  True on success

virtual bool addTableRow | ( | const String & | item,
|  | const NamedList * | data = `0`,
|  | bool | atStart = `false`
| ) |  |
| inline virtual

Add a row to a table

Parameters

  item | Name of the item to add
  data | Table's columns to set
  atStart | True to insert, false to append

Returns
  True if the operation was successfull

virtual bool clearTable | ( |  | ) |
| inline virtual

Clear (delete all rows) a table

Returns
  True if the operation was successfull

virtual bool delTableRow | ( | const String & | item | ) |
| inline virtual

Delete a row from a table

Parameters

  item | Name of the item to remove

Returns
  True if the operation was successfull

virtual bool getOptions | ( | NamedList & | items | ) |
| inline virtual

Get widget's items

Parameters

  items | List to fill with widget's items

Returns
  False on failure (e.g. not initialized)

virtual bool getSelect | ( | String & | item | ) |
| inline virtual

Retrieve the widget's selection

Parameters

  item | String to fill with selection's contents

Returns
  True if the operation was successfull

virtual bool getSelect | ( | NamedList & | items | ) |
| inline virtual

Retrieve widget's multiple selection

Parameters

  items | List to be to filled with selection's contents

Returns
  True if the operation was successfull

virtual bool getTableRow | ( | const String & | item,
|  | NamedList * | data = `0`
| ) |  |
| inline virtual

Retrieve a row from a table

Parameters

  item | Name of the item to retrieve
  data | List to fill with table's columns contents

Returns
  True if the operation was successfull

virtual bool getText | ( | String & | text,
|  | bool | richText = `false`
| ) |  |
| inline virtual

Retrieve the displayed text of this widget

Parameters

  text | Text value
  richText | True to retrieve formatted data

Returns
  True on success

virtual bool insertTableRow | ( | const String & | item,
|  | const String & | before,
|  | const NamedList * | data = `0`
| ) |  |
| inline virtual

Insert a row into a table

Parameters

  item | Name of the item to insert
  before | Name of the item to insert before
  data | Table's columns to set

Returns
  True if the operation was successfull

const String& name | ( |  | ) | const
| inline

Retrieve the standard name of this Window

Returns
  Identifier of this window

References String::toString().

virtual bool setBusy | ( | bool | on | ) |
| inline virtual

Show or hide control busy state

Parameters

  on | True to show, false to hide

Returns
  True if all the operations were successfull

virtual bool setMultipleRows | ( | const NamedList & | data,
|  | const String & | prefix = `String::empty()`
| ) |  |
| inline virtual

Append or update several table rows at once

Parameters

  data | Parameters to initialize the rows with
  prefix | Prefix to match (and remove) in parameter names

Returns
  True if all the operations were successfull

virtual bool setParams | ( | const NamedList & | params | ) |
| inline virtual

Set widget's parameters

Parameters

  params | List of parameters

Returns
  True if all parameters could be set

virtual bool setSelect | ( | const String & | item | ) |
| inline virtual

Set the widget's selection

Parameters

  item | String containing the new selection

Returns
  True if the operation was successfull

virtual bool setTableRow | ( | const String & | item,
|  | const NamedList * | data
| ) |  |
| inline virtual

Update a table's row

Parameters

  item | Name of the item to update
  data | Data to update

Returns
  True if the operation was successfull

virtual bool setText | ( | const String & | text,
|  | bool | richText = `false`
| ) |  |
| inline virtual

Set the displayed text of this widget

Parameters

  text | Text value to set
  richText | True if the text contains format data

Returns
  True on success

virtual bool updateTableRows | ( | const NamedList * | data,
|  | bool | atStart = `false`
| ) |  |
| inline virtual

Add or set one or more table row(s). Screen update is locked while changing the table. Each data list element is a NamedPointer carrying a NamedList with item parameters. The name of an element is the item to update. Set element's value to boolean value 'true' to add a new item if not found or 'false' to set an existing one. Set it to empty string to delete the item

Parameters

  data | The list of items to add/set/delete
  atStart | True to add new items at start, false to add them to the end

Returns
  True if the operation was successfull

The documentation for this class was generated from the following file:

- yatecbase.h